﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace PeteBrown.SilverlightSoundTest.Synth.Envelopes
{
    public enum AdsrEnvelopeState
    {
        Attack,
        Decay,
        Sustain,
        Release,
        Completed
    }

    public class EnvelopeState
    {
        private AdsrEnvelopeState _state { get; set; }
        //private TimeSpan _elapsedTime;
        private double _elapsedTimeInSeconds;

        public EnvelopeState()
        {
            State = AdsrEnvelopeState.Completed;
        }

        public void IncrementElapsedTime(double seconds)
        {
            //_elapsedTime = _elapsedTime.Add(TimeSpan.FromSeconds(seconds));
            _elapsedTimeInSeconds += seconds;
        }

        //public TimeSpan ElapsedTimeAtCurrentState
        //{
        //    get { return _elapsedTime; }
        //    set { _elapsedTime = value; }
        //}

        public double ElapsedSecondsAtCurrentState
        {
            get { return _elapsedTimeInSeconds; }
        }

        public AdsrEnvelopeState State
        {
            get { return _state; }
            set 
            { 
                _state = value; 
                //ElapsedTimeAtCurrentState = TimeSpan.FromSeconds(0);
                _elapsedTimeInSeconds = 0;
            }
        }



    }
}
