﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using PeteBrown.SilverlightSoundTest.Synth.Wave;
using PeteBrown.SilverlightSoundTest.Synth.Filters;
using PeteBrown.SilverlightSoundTest.Synth.Envelopes;

namespace PeteBrown.SilverlightSoundTest.Synth.Oscillators
{
    public interface IOscillator
    {
        void Initialize(SoundBuffer<MonoSample> buffer, OscillatorParameters parameters);

        //IFilter Filter { get; set; }

        SoundBuffer<MonoSample> Buffer { get; }

        OscillatorParameters Parameters { get; }


        // this is used for visualization
        SoundBuffer<MonoSample> OutputOneCompleteCycle(Note note);

        //IOscillator SyncSource { get; set; }
        //public bool SyncSlave { get; }  // this requires we only output a sample at a time

        void Output(long offset, int count);

        void Trigger(Note currentNote);
        void Release();

        bool IsGeneratingSound { get; }

    }
}
