﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace PeteBrown.SilverlightSoundTest.Synth
{
    public class Pan : INotifyPropertyChanged
    {
        public const double Left = -1;
        public const double Right = 1;
        public const double Center = 0;

        private double _position;

        public Pan(double position)
        {
            _position = ScrubPosition(position);
        }

        public double Position
        {
            get { return _position; }
            set { _position = ScrubPosition(value); NotifyChanged("Position"); }
        }


        private double ScrubPosition(double position)
        {
            if (position < Left) return Left;
            if (position > Right) return Right;
            
            return position;
        }


        #region INotifyPropertyChanged Members

        private void NotifyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }


        public event PropertyChangedEventHandler PropertyChanged;


        #endregion

    }
}
