﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace PeteBrown.SilverlightSoundTest.Synth
{
    public class Percent : INotifyPropertyChanged
    {
        private double _value;


        public Percent()
        {
        }

        public Percent(double value)
        {
            Value = value;
        }

        public double Value
        {
            get { return _value; }
            set { _value = CleanValue(value); NotifyChanged("Value"); }
        }

        private double CleanValue(double value)
        {
            if (value < 0)
                return 0.0;
            else if (value > 1)
                return 1.0;
            else
                return value;
        }



        #region INotifyPropertyChanged Members

        private void NotifyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }


        public event PropertyChangedEventHandler PropertyChanged;


        #endregion



    }
}
