﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace PeteBrown.SilverlightSoundTest.Synth
{
    public class Range<T> : INotifyPropertyChanged where T: IComparable
    {
        private T _min;
        private T _max;
        private T _step;

        public Range(T min, T max, T step)
        {
            _min = min;
            _max = max;
            _step = step;
        }

        public T Minimum
        {
            get { return _min; }
            set { _min = value; NotifyChanged("Minimum"); }
        }

        public T Maximum
        {
            get { return _max; }
            set { _max = value; NotifyChanged("Maximum"); }
        }

        public T Step
        {
            get { return _step; }
            set { _step = value; NotifyChanged("Step"); }
        }



        #region INotifyPropertyChanged Members

        private void NotifyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }


        public event PropertyChangedEventHandler PropertyChanged;


        #endregion


    }
}
