﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace PeteBrown.SilverlightSoundTest.Synth
{
    public class SoundBuffer<T> : IEnumerable<T> where T : class
    {
        private T[] _buffer;

        public SoundBuffer(int bufferSize)
        {
            _buffer = new T[bufferSize];
        }

        public T this[int index]
        {
            get { return _buffer[index]; }
            set { _buffer[index] = value; }
        }

        public int Length
        {
            get { return _buffer.Length; }
        }

        public void Clear()
        {
            for (int i = 0; i < _buffer.Length; i++)
            {
                //_buffer[i] = default(T);
                //_buffer[i] = new T();
                _buffer[i] = null;
            }
        }

        #region IEnumerable<T> Members

        IEnumerator<T> IEnumerable<T>.GetEnumerator()
        {
            return (IEnumerator<T>)_buffer.GetEnumerator();
        }

        #endregion

        #region IEnumerable Members

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return _buffer.GetEnumerator();
        }

        #endregion
    }
}
