﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace PeteBrown.SilverlightSoundTest.Synth.Utilities
{
    public static class MathUtility
    {
        public static readonly double TwoPI = 2 * Math.PI;
        public static readonly double TwelveRootOfTwo = Math.Pow(2, 1 / 12);

        static MathUtility()
        { }


        // for calculating the y value a point (x, ?) on the line that starts at (0,0) and ends at (x2,y2)
        // used in linear attack calculation
        public static double GetYValueOnLineFromOrigin(double x2, double y2, double x)
        {
            double slope = y2 / x2 ;

            return slope * x;
        }


        // for calculating the y value a point (x, ?) on the line that starts at (x1,y1) and ends at (x2,y2)
        // used in linear attack calculation
        public static double GetYValueOnLine(double x1, double y1, double x2, double y2, double b, double x)
        {
            double slope = (y1 - y2) / (x1 - x2);

            return slope * x + b;
        }
    
    
    }
}
