﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace PeteBrown.SilverlightSoundTest.Synth.Wave
{
    public class WhiteNoiseWaveform : IWaveform
    {
        private SampleRate _sampleRate;

        private Random _random = new Random();

        #region IWaveform Members

        public void Initialize(SampleRate rate)
        {
            _sampleRate = rate;
        }

        public MonoSample GetSample(double frequency, WaveformState state)
        {
            // this is noise, so don't bother taking the hit doing a Math.Round.

            int value = (int)(_random.Next(state.MaxAmplitude.Value *-1, state.MaxAmplitude.Value) * (int)state.Polarity);

            return new MonoSample(value);
        }


        public WaveformState GetNewState()
        {
            return new WaveformState(1);
        }

        // GetSampleCount for whitenoise is pretty meaningless
        public int GetSampleCount(double frequency)
        {
            return (int)Math.Round(_sampleRate.SamplesPerSecond / frequency, 0);
        }



        #endregion
    }
}
