﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using PeteBrown.SilverlightSoundTest.Synth;

namespace PeteBrown.SilverlightSoundTest.UI
{
    public partial class MixerEditor : UserControl
    {
        private Synthesizer _synth;

        private StereoSample _peak = new StereoSample();

        public MixerEditor()
        {
            InitializeComponent();

            CompositionTarget.Rendering += new EventHandler(CompositionTarget_Rendering);
        }

        void CompositionTarget_Rendering(object sender, EventArgs e)
        {
            // update the peak meter

            double maxHeight = PeakLeftMax.ActualHeight;

            PeakLeft.Height = Math.Round((double)_peak.Left / int.MaxValue * maxHeight, 0);
            PeakRight.Height = Math.Round((double)_peak.Right / int.MaxValue * maxHeight, 0);
        }



        void _synth_BufferPlayed(object sender, BufferPlayedEventArgs e)
        {
            // Temp visualization for peak levels

            // for ui workload reasons, might make sense to throttle this to happen maybe only on render or something

            _peak = e.PeakValues;

            //PeakLeft.Dispatcher.BeginInvoke(new Action(delegate
            //{
                
            //    PeakLeft.Height = Math.Round((double)e.PeakValues.Left / int.MaxValue * PeakLeftMax.ActualHeight, 0);
            //    PeakRight.Height = Math.Round((double)e.PeakValues.Right / int.MaxValue * PeakRightMax.ActualHeight, 0);
            //}));

        }

        public Synthesizer Synth
        {
            get { return _synth; }
            set
            {
                _synth = value;
                _synth.BufferPlayed += new EventHandler<BufferPlayedEventArgs>(_synth_BufferPlayed);

                LayoutRoot.DataContext = _synth;

            }
        }

    }
}
